/* 
	Created on : 2018-07-22
	Author	: UAB Euro Info
*/
(function($){
	if(typeof postit_data !== 'object'){
		return;
	}
	if(typeof window.console === 'undefined') {
		window.console = {
			log: function (msg){},
			warn: function (msg){}
		};
	}
	
	var address_xhr;
	var $address = $(postit_data.params.address);
	
	if($address.length === 0 || typeof $address.autocomplete !== 'function'){
		console.warn('postit.lt - Address input not found');
		return;
	}
	
	
	$address.autocomplete({
		minLength: 4,
		delay: 400,
		source: function(request, response){
			var element = this.element;
			$(element).addClass('loading');
			
			var request_data = $.extend(postit_data.args, {term: $.trim(request.term)});
			
			if($(postit_data.params.country).val().toLowerCase() !== 'lt'){
				return;
			}
			
			if(address_xhr){
				address_xhr.abort();
			}
			address_xhr = $.ajax({
				url: postit_data.url,
				dataType: 'json',
				crossDomain: true,
				data: request_data,
				success: function(resp){
					var r = [];
					if ( !resp.success ){
						console.warn(postit_data.url + ' - ' + resp.message);
						response(r);
						return;
					}
					
					for( var i = 0, l = resp.data.length; i < l; i++ ){
						var t = '';
						var address = resp.data[i].address;
						var municipality = resp.data[i].municipality;
						
						if ( resp.data[i].address === '' ){
							//Šis atvejis nutinka tada, kai ieškoma ne pagal adresą, o pagal pašto kodą arba vietovę
							if(resp.data[i].mailbox !== ''){
								//Pvz.: ieškant pagal "00002" ar "Pašto dėžutė 1"
								address = ('Post Box ' + resp.data[i].mailbox);
								t = (address + ', ' + resp.data[i].city);
							}
							else {
								//Pvz.: ieškant pagal "20100" ar "Bernotiškių k."
								t = (resp.data[i].city + ', ' + resp.data[i].municipality);
							}
						} else {
							t = (resp.data[i].address + ', ' + resp.data[i].city);
						}
						r.push({
							label: t + ', ' + postit_data.config.prefix + resp.data[i].post_code + postit_data.config.label_sufix,
							value: address,
							address: address,
							municipality: municipality,
							city: resp.data[i].city,
							post_code: resp.data[i].post_code
						});
						response(r);
					}
					
				},
				error: function(){
					response([]);
				},
				complete: function(){
					$(element).removeClass('loading');
				}
			});
		},
		select: function(event, ui){
			$(postit_data.params.postcode).val(postit_data.config.prefix + ui.item.post_code);
			$(postit_data.params.city).val(ui.item.city);
			$(postit_data.params.address).val(ui.item.address);
			$(postit_data.params.municipality).val(ui.item.municipality);
		}
	});
})(jQuery);